//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the prosilica_camera package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __prosilica_camera__PROSILICACAMERACONFIG_H__
#define __prosilica_camera__PROSILICACAMERACONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace prosilica_camera
{
  class ProsilicaCameraConfigStatics;
  
  class ProsilicaCameraConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(ProsilicaCameraConfig &config, const ProsilicaCameraConfig &max, const ProsilicaCameraConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const ProsilicaCameraConfig &config1, const ProsilicaCameraConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, ProsilicaCameraConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const ProsilicaCameraConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ProsilicaCameraConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const ProsilicaCameraConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T ProsilicaCameraConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (ProsilicaCameraConfig::* field);

      virtual void clamp(ProsilicaCameraConfig &config, const ProsilicaCameraConfig &max, const ProsilicaCameraConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const ProsilicaCameraConfig &config1, const ProsilicaCameraConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, ProsilicaCameraConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const ProsilicaCameraConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ProsilicaCameraConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const ProsilicaCameraConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 19 "../cfg/ProsilicaCamera.cfg"
      std::string trigger_mode;
//#line 20 "../cfg/ProsilicaCamera.cfg"
      bool auto_exposure;
//#line 21 "../cfg/ProsilicaCamera.cfg"
      double exposure;
//#line 22 "../cfg/ProsilicaCamera.cfg"
      bool auto_gain;
//#line 23 "../cfg/ProsilicaCamera.cfg"
      int gain;
//#line 24 "../cfg/ProsilicaCamera.cfg"
      bool auto_whitebalance;
//#line 25 "../cfg/ProsilicaCamera.cfg"
      int whitebalance_red;
//#line 26 "../cfg/ProsilicaCamera.cfg"
      int whitebalance_blue;
//#line 27 "../cfg/ProsilicaCamera.cfg"
      int binning_x;
//#line 28 "../cfg/ProsilicaCamera.cfg"
      int binning_y;
//#line 29 "../cfg/ProsilicaCamera.cfg"
      int x_offset;
//#line 30 "../cfg/ProsilicaCamera.cfg"
      int y_offset;
//#line 31 "../cfg/ProsilicaCamera.cfg"
      int width;
//#line 32 "../cfg/ProsilicaCamera.cfg"
      int height;
//#line 33 "../cfg/ProsilicaCamera.cfg"
      std::string frame_id;
//#line 34 "../cfg/ProsilicaCamera.cfg"
      std::string trig_timestamp_topic;
//#line 35 "../cfg/ProsilicaCamera.cfg"
      double trig_rate;
//#line 36 "../cfg/ProsilicaCamera.cfg"
      int stream_bytes_per_second;
//#line 37 "../cfg/ProsilicaCamera.cfg"
      bool auto_adjust_stream_bytes_per_second;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("ProsilicaCameraConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const ProsilicaCameraConfig &__max__ = __getMax__();
      const ProsilicaCameraConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const ProsilicaCameraConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const ProsilicaCameraConfig &__getDefault__();
    static const ProsilicaCameraConfig &__getMax__();
    static const ProsilicaCameraConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const ProsilicaCameraConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void ProsilicaCameraConfig::ParamDescription<std::string>::clamp(ProsilicaCameraConfig &config, const ProsilicaCameraConfig &max, const ProsilicaCameraConfig &min) const
  {
    return;
  }

  class ProsilicaCameraConfigStatics
  {
    friend class ProsilicaCameraConfig;
    
    ProsilicaCameraConfigStatics()
    {
//#line 19 "../cfg/ProsilicaCamera.cfg"
      __min__.trigger_mode = "";
//#line 19 "../cfg/ProsilicaCamera.cfg"
      __max__.trigger_mode = "";
//#line 19 "../cfg/ProsilicaCamera.cfg"
      __default__.trigger_mode = "streaming";
//#line 19 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<std::string>("trigger_mode", "str", 1, "Camera Trigger mode", "{'enum_description': 'Enum to set the trigger mode', 'enum': [{'srcline': 11, 'description': 'Run at maximum frame rate', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'streaming', 'ctype': 'std::string', 'type': 'str', 'name': 'StreamingMode'}, {'srcline': 12, 'description': 'Capture frame in response to service call', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'polled', 'ctype': 'std::string', 'type': 'str', 'name': 'PolledMode'}, {'srcline': 14, 'description': 'External trigger on SyncIn1 line', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'syncin1', 'ctype': 'std::string', 'type': 'str', 'name': 'External1Mode'}, {'srcline': 15, 'description': 'External trigger on SyncIn2 line', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'syncin2', 'ctype': 'std::string', 'type': 'str', 'name': 'External2Mode'}]}", &ProsilicaCameraConfig::trigger_mode)));
//#line 20 "../cfg/ProsilicaCamera.cfg"
      __min__.auto_exposure = 0;
//#line 20 "../cfg/ProsilicaCamera.cfg"
      __max__.auto_exposure = 1;
//#line 20 "../cfg/ProsilicaCamera.cfg"
      __default__.auto_exposure = 1;
//#line 20 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<bool>("auto_exposure", "bool", 0, "Sets the camera exposure duration to automatic. Causes the @b exposure setting to be ignored.", "", &ProsilicaCameraConfig::auto_exposure)));
//#line 21 "../cfg/ProsilicaCamera.cfg"
      __min__.exposure = 2.5e-05;
//#line 21 "../cfg/ProsilicaCamera.cfg"
      __max__.exposure = 60.0;
//#line 21 "../cfg/ProsilicaCamera.cfg"
      __default__.exposure = 0.025;
//#line 21 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<double>("exposure", "double", 0, "Camera exposure time in seconds.", "", &ProsilicaCameraConfig::exposure)));
//#line 22 "../cfg/ProsilicaCamera.cfg"
      __min__.auto_gain = 0;
//#line 22 "../cfg/ProsilicaCamera.cfg"
      __max__.auto_gain = 1;
//#line 22 "../cfg/ProsilicaCamera.cfg"
      __default__.auto_gain = 1;
//#line 22 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<bool>("auto_gain", "bool", 0, "Sets the analog gain to automatic. Causes the @b gain setting to be ignored.", "", &ProsilicaCameraConfig::auto_gain)));
//#line 23 "../cfg/ProsilicaCamera.cfg"
      __min__.gain = 0;
//#line 23 "../cfg/ProsilicaCamera.cfg"
      __max__.gain = 24;
//#line 23 "../cfg/ProsilicaCamera.cfg"
      __default__.gain = 0;
//#line 23 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("gain", "int", 0, "The gain level in dB.", "", &ProsilicaCameraConfig::gain)));
//#line 24 "../cfg/ProsilicaCamera.cfg"
      __min__.auto_whitebalance = 0;
//#line 24 "../cfg/ProsilicaCamera.cfg"
      __max__.auto_whitebalance = 1;
//#line 24 "../cfg/ProsilicaCamera.cfg"
      __default__.auto_whitebalance = 1;
//#line 24 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<bool>("auto_whitebalance", "bool", 0, "Whether whitebalance will continuously adjust to the current scene. Causes the @b whitebalance_red and @b whitebalance_blue settings to be ignored.", "", &ProsilicaCameraConfig::auto_whitebalance)));
//#line 25 "../cfg/ProsilicaCamera.cfg"
      __min__.whitebalance_red = 80;
//#line 25 "../cfg/ProsilicaCamera.cfg"
      __max__.whitebalance_red = 300;
//#line 25 "../cfg/ProsilicaCamera.cfg"
      __default__.whitebalance_red = 100;
//#line 25 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("whitebalance_red", "int", 0, "Red gain as a percentage of the camera default setting.", "", &ProsilicaCameraConfig::whitebalance_red)));
//#line 26 "../cfg/ProsilicaCamera.cfg"
      __min__.whitebalance_blue = 80;
//#line 26 "../cfg/ProsilicaCamera.cfg"
      __max__.whitebalance_blue = 300;
//#line 26 "../cfg/ProsilicaCamera.cfg"
      __default__.whitebalance_blue = 100;
//#line 26 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("whitebalance_blue", "int", 0, "Blue gain as a percentage of the camera default setting.", "", &ProsilicaCameraConfig::whitebalance_blue)));
//#line 27 "../cfg/ProsilicaCamera.cfg"
      __min__.binning_x = 1;
//#line 27 "../cfg/ProsilicaCamera.cfg"
      __max__.binning_x = 8;
//#line 27 "../cfg/ProsilicaCamera.cfg"
      __default__.binning_x = 1;
//#line 27 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("binning_x", "int", 0, "Number of pixels to bin together horizontally.", "", &ProsilicaCameraConfig::binning_x)));
//#line 28 "../cfg/ProsilicaCamera.cfg"
      __min__.binning_y = 1;
//#line 28 "../cfg/ProsilicaCamera.cfg"
      __max__.binning_y = 14;
//#line 28 "../cfg/ProsilicaCamera.cfg"
      __default__.binning_y = 1;
//#line 28 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("binning_y", "int", 0, "Number of pixels to bin together vertically.", "", &ProsilicaCameraConfig::binning_y)));
//#line 29 "../cfg/ProsilicaCamera.cfg"
      __min__.x_offset = 0;
//#line 29 "../cfg/ProsilicaCamera.cfg"
      __max__.x_offset = 2447;
//#line 29 "../cfg/ProsilicaCamera.cfg"
      __default__.x_offset = 0;
//#line 29 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("x_offset", "int", 0, "X offset of the region of interest.", "", &ProsilicaCameraConfig::x_offset)));
//#line 30 "../cfg/ProsilicaCamera.cfg"
      __min__.y_offset = 0;
//#line 30 "../cfg/ProsilicaCamera.cfg"
      __max__.y_offset = 2049;
//#line 30 "../cfg/ProsilicaCamera.cfg"
      __default__.y_offset = 0;
//#line 30 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("y_offset", "int", 0, "Y offset of the region of interest.", "", &ProsilicaCameraConfig::y_offset)));
//#line 31 "../cfg/ProsilicaCamera.cfg"
      __min__.width = 0;
//#line 31 "../cfg/ProsilicaCamera.cfg"
      __max__.width = 2448;
//#line 31 "../cfg/ProsilicaCamera.cfg"
      __default__.width = 0;
//#line 31 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("width", "int", 0, "Width of the region of interest (0 for automatic).", "", &ProsilicaCameraConfig::width)));
//#line 32 "../cfg/ProsilicaCamera.cfg"
      __min__.height = 0;
//#line 32 "../cfg/ProsilicaCamera.cfg"
      __max__.height = 2050;
//#line 32 "../cfg/ProsilicaCamera.cfg"
      __default__.height = 0;
//#line 32 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("height", "int", 0, "Height of the region of interest (0 for automatic).", "", &ProsilicaCameraConfig::height)));
//#line 33 "../cfg/ProsilicaCamera.cfg"
      __min__.frame_id = "";
//#line 33 "../cfg/ProsilicaCamera.cfg"
      __max__.frame_id = "";
//#line 33 "../cfg/ProsilicaCamera.cfg"
      __default__.frame_id = "";
//#line 33 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<std::string>("frame_id", "str", 0, "The optical camera TF frame set in message headers.", "", &ProsilicaCameraConfig::frame_id)));
//#line 34 "../cfg/ProsilicaCamera.cfg"
      __min__.trig_timestamp_topic = "";
//#line 34 "../cfg/ProsilicaCamera.cfg"
      __max__.trig_timestamp_topic = "";
//#line 34 "../cfg/ProsilicaCamera.cfg"
      __default__.trig_timestamp_topic = "";
//#line 34 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<std::string>("trig_timestamp_topic", "str", 1, "Sets the topic from which an externally trigged camera receives its trigger timestamps.", "", &ProsilicaCameraConfig::trig_timestamp_topic)));
//#line 35 "../cfg/ProsilicaCamera.cfg"
      __min__.trig_rate = 1.0;
//#line 35 "../cfg/ProsilicaCamera.cfg"
      __max__.trig_rate = 100.0;
//#line 35 "../cfg/ProsilicaCamera.cfg"
      __default__.trig_rate = 15.0;
//#line 35 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<double>("trig_rate", "double", 0, "Sets the expected triggering rate in externally triggered mode.", "", &ProsilicaCameraConfig::trig_rate)));
//#line 36 "../cfg/ProsilicaCamera.cfg"
      __min__.stream_bytes_per_second = 1;
//#line 36 "../cfg/ProsilicaCamera.cfg"
      __max__.stream_bytes_per_second = 115000000;
//#line 36 "../cfg/ProsilicaCamera.cfg"
      __default__.stream_bytes_per_second = 45000000;
//#line 36 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<int>("stream_bytes_per_second", "int", 0, "Sets the StreamBytesPerSecond property.", "", &ProsilicaCameraConfig::stream_bytes_per_second)));
//#line 37 "../cfg/ProsilicaCamera.cfg"
      __min__.auto_adjust_stream_bytes_per_second = 0;
//#line 37 "../cfg/ProsilicaCamera.cfg"
      __max__.auto_adjust_stream_bytes_per_second = 1;
//#line 37 "../cfg/ProsilicaCamera.cfg"
      __default__.auto_adjust_stream_bytes_per_second = 1;
//#line 37 "../cfg/ProsilicaCamera.cfg"
      __param_descriptions__.push_back(ProsilicaCameraConfig::AbstractParamDescriptionConstPtr(new ProsilicaCameraConfig::ParamDescription<bool>("auto_adjust_stream_bytes_per_second", "bool", 0, "Enables automatic optimization of the StreamBytesPerSecond property.", "", &ProsilicaCameraConfig::auto_adjust_stream_bytes_per_second)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<ProsilicaCameraConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<ProsilicaCameraConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    ProsilicaCameraConfig __max__;
    ProsilicaCameraConfig __min__;
    ProsilicaCameraConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const ProsilicaCameraConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static ProsilicaCameraConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &ProsilicaCameraConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const ProsilicaCameraConfig &ProsilicaCameraConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const ProsilicaCameraConfig &ProsilicaCameraConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const ProsilicaCameraConfig &ProsilicaCameraConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<ProsilicaCameraConfig::AbstractParamDescriptionConstPtr> &ProsilicaCameraConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const ProsilicaCameraConfigStatics *ProsilicaCameraConfig::__get_statics__()
  {
    const static ProsilicaCameraConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = ProsilicaCameraConfigStatics::get_instance();
    
    return statics;
  }

//#line 11 "../cfg/ProsilicaCamera.cfg"
      const char * const ProsilicaCamera_StreamingMode = "streaming";
//#line 12 "../cfg/ProsilicaCamera.cfg"
      const char * const ProsilicaCamera_PolledMode = "polled";
//#line 14 "../cfg/ProsilicaCamera.cfg"
      const char * const ProsilicaCamera_External1Mode = "syncin1";
//#line 15 "../cfg/ProsilicaCamera.cfg"
      const char * const ProsilicaCamera_External2Mode = "syncin2";
}

#endif // __PROSILICACAMERARECONFIGURATOR_H__
