## *********************************************************
## 
## File autogenerated for the prosilica_camera package 
## by the dynamic_reconfigure package.
## Please do not edit.
## 
## ********************************************************/

##**********************************************************
## Software License Agreement (BSD License)
##
##  Copyright (c) 2008, Willow Garage, Inc.
##  All rights reserved.
##
##  Redistribution and use in source and binary forms, with or without
##  modification, are permitted provided that the following conditions
##  are met:
##
##   * Redistributions of source code must retain the above copyright
##     notice, this list of conditions and the following disclaimer.
##   * Redistributions in binary form must reproduce the above
##     copyright notice, this list of conditions and the following
##     disclaimer in the documentation and/or other materials provided
##     with the distribution.
##   * Neither the name of the Willow Garage nor the names of its
##     contributors may be used to endorse or promote products derived
##     from this software without specific prior written permission.
##
##  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
##  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
##  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
##  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
##  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
##  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
##  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
##  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
##  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
##  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
##  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
##  POSSIBILITY OF SUCH DAMAGE.
##**********************************************************/

config_description = [{'srcline': 19, 'description': 'Camera Trigger mode', 'max': '', 'cconsttype': 'const char * const', 'ctype': 'std::string', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'trigger_mode', 'edit_method': "{'enum_description': 'Enum to set the trigger mode', 'enum': [{'srcline': 11, 'description': 'Run at maximum frame rate', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'streaming', 'ctype': 'std::string', 'type': 'str', 'name': 'StreamingMode'}, {'srcline': 12, 'description': 'Capture frame in response to service call', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'polled', 'ctype': 'std::string', 'type': 'str', 'name': 'PolledMode'}, {'srcline': 14, 'description': 'External trigger on SyncIn1 line', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'syncin1', 'ctype': 'std::string', 'type': 'str', 'name': 'External1Mode'}, {'srcline': 15, 'description': 'External trigger on SyncIn2 line', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'cconsttype': 'const char * const', 'value': 'syncin2', 'ctype': 'std::string', 'type': 'str', 'name': 'External2Mode'}]}", 'default': 'streaming', 'level': 1, 'min': '', 'type': 'str'}, {'srcline': 20, 'description': 'Sets the camera exposure duration to automatic. Causes the @b exposure setting to be ignored.', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'auto_exposure', 'edit_method': '', 'default': True, 'level': 0, 'min': False, 'type': 'bool'}, {'srcline': 21, 'description': 'Camera exposure time in seconds.', 'max': 60.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'exposure', 'edit_method': '', 'default': 0.025, 'level': 0, 'min': 2.5e-05, 'type': 'double'}, {'srcline': 22, 'description': 'Sets the analog gain to automatic. Causes the @b gain setting to be ignored.', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'auto_gain', 'edit_method': '', 'default': True, 'level': 0, 'min': False, 'type': 'bool'}, {'srcline': 23, 'description': 'The gain level in dB.', 'max': 24, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'gain', 'edit_method': '', 'default': 0, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 24, 'description': 'Whether whitebalance will continuously adjust to the current scene. Causes the @b whitebalance_red and @b whitebalance_blue settings to be ignored.', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'auto_whitebalance', 'edit_method': '', 'default': True, 'level': 0, 'min': False, 'type': 'bool'}, {'srcline': 25, 'description': 'Red gain as a percentage of the camera default setting.', 'max': 300, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'whitebalance_red', 'edit_method': '', 'default': 100, 'level': 0, 'min': 80, 'type': 'int'}, {'srcline': 26, 'description': 'Blue gain as a percentage of the camera default setting.', 'max': 300, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'whitebalance_blue', 'edit_method': '', 'default': 100, 'level': 0, 'min': 80, 'type': 'int'}, {'srcline': 27, 'description': 'Number of pixels to bin together horizontally.', 'max': 8, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'binning_x', 'edit_method': '', 'default': 1, 'level': 0, 'min': 1, 'type': 'int'}, {'srcline': 28, 'description': 'Number of pixels to bin together vertically.', 'max': 14, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'binning_y', 'edit_method': '', 'default': 1, 'level': 0, 'min': 1, 'type': 'int'}, {'srcline': 29, 'description': 'X offset of the region of interest.', 'max': 2447, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'x_offset', 'edit_method': '', 'default': 0, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 30, 'description': 'Y offset of the region of interest.', 'max': 2049, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'y_offset', 'edit_method': '', 'default': 0, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 31, 'description': 'Width of the region of interest (0 for automatic).', 'max': 2448, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'width', 'edit_method': '', 'default': 0, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 32, 'description': 'Height of the region of interest (0 for automatic).', 'max': 2050, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'height', 'edit_method': '', 'default': 0, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 33, 'description': 'The optical camera TF frame set in message headers.', 'max': '', 'cconsttype': 'const char * const', 'ctype': 'std::string', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'frame_id', 'edit_method': '', 'default': '', 'level': 0, 'min': '', 'type': 'str'}, {'srcline': 34, 'description': 'Sets the topic from which an externally trigged camera receives its trigger timestamps.', 'max': '', 'cconsttype': 'const char * const', 'ctype': 'std::string', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'trig_timestamp_topic', 'edit_method': '', 'default': '', 'level': 1, 'min': '', 'type': 'str'}, {'srcline': 35, 'description': 'Sets the expected triggering rate in externally triggered mode.', 'max': 100.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'trig_rate', 'edit_method': '', 'default': 15.0, 'level': 0, 'min': 1.0, 'type': 'double'}, {'srcline': 36, 'description': 'Sets the StreamBytesPerSecond property.', 'max': 115000000, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'stream_bytes_per_second', 'edit_method': '', 'default': 45000000, 'level': 0, 'min': 1, 'type': 'int'}, {'srcline': 37, 'description': 'Enables automatic optimization of the StreamBytesPerSecond property.', 'max': True, 'cconsttype': 'const bool', 'ctype': 'bool', 'srcfile': '../cfg/ProsilicaCamera.cfg', 'name': 'auto_adjust_stream_bytes_per_second', 'edit_method': '', 'default': True, 'level': 0, 'min': False, 'type': 'bool'}]

min = {}
max = {}
defaults = {}
level = {}
type = {}
all_level = 0

for param in config_description:
    min[param['name']] = param['min']
    max[param['name']] = param['max']
    defaults[param['name']] = param['default']
    level[param['name']] = param['level']
    type[param['name']] = param['type']
    all_level = all_level | param['level']

ProsilicaCamera_StreamingMode = 'streaming'
ProsilicaCamera_PolledMode = 'polled'
ProsilicaCamera_External1Mode = 'syncin1'
ProsilicaCamera_External2Mode = 'syncin2'
